package snail.fb.share;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import com.facebook.CallbackManager;
import com.facebook.FacebookCallback;
import com.facebook.FacebookSdk;
import com.facebook.share.Sharer;
import com.facebook.share.model.AppInviteContent;
import com.facebook.share.model.ShareLinkContent;
import com.facebook.share.model.SharePhoto;
import com.facebook.share.model.SharePhotoContent;
import com.facebook.share.widget.AppInviteDialog;
import com.facebook.share.widget.ShareDialog;

public class SnailFBShare {

	
	private static ShareDialog shareDialog;
	
	
	/**
	 * ʼFB
	 * @param activity
	 * @param callManager
	 * @param fbCallback
	 */
	public static void initFB(Activity activity,CallbackManager callManager, FacebookCallback<Sharer.Result> fbCallback){
		FacebookSdk.sdkInitialize(activity.getApplicationContext());
		shareDialog = new ShareDialog(activity);
		shareDialog.registerCallback(callManager, fbCallback);
	}
	
	
	/**
	 * ͼƬ
	 * @param imagePath
	 */
	public static void shareLocalImage(String imagePath){
		if (ShareDialog.canShow(SharePhotoContent.class)) {
			Bundle postParams = new Bundle();
			Bitmap bitmap = BitmapFactory.decodeFile(imagePath);
			SharePhoto photo = new SharePhoto.Builder()
			.setBitmap(bitmap)
			.setParameters(postParams)
			.build();
			SharePhotoContent photoContent = new SharePhotoContent.Builder()
			.addPhoto(photo)
			.build();
			shareDialog.show(photoContent);
		}
	}
	
	
	/**
	 * ıϢҳͼƬ
	 * @param title  
	 * @param content  
	 * @param imageUrl  ͼƬַ
	 * @param contentUrl  ʾͼƬ
	 */
	public static void shareText(String title, String content, String imageUrl, String contentUrl){
		if (ShareDialog.canShow(ShareLinkContent.class)) {
			ShareLinkContent linkContent = new ShareLinkContent.Builder()
			.setContentTitle(title)//
			.setContentDescription(content)//
			.setImageUrl(Uri.parse(imageUrl))//ʾҪͼƬַ
			.setContentUrl(Uri.parse(contentUrl))//ʾͼƬҵͼƬת
			.build();
			shareDialog.show(linkContent);
		}
	}
	
	
	/**
	 *  
	 * @param activity  Ӧ
	 * @param appLinkUrl  Ӧں̨ link
	 * @param previewImageUrl  ʱʾͼƬĵַ
	 */
	public static void facebookInvlte(Activity activity, String appLinkUrl, String previewImageUrl, CallbackManager callManager, FacebookCallback<AppInviteDialog.Result> fbCallback){
		AppInviteDialog dialog = new AppInviteDialog(activity);
		dialog.registerCallback(callManager, fbCallback);
		if (AppInviteDialog.canShow()) {
		    AppInviteContent content = new AppInviteContent.Builder()
		                .setApplinkUrl(appLinkUrl)
		                .setPreviewImageUrl(previewImageUrl)
		                .build();
		    dialog.show(content);
		}
	}
	
	
}
